LOCAL_PATH := $(QFUSION_PATH)/libsrcs/libRocket/libRocket
include $(CLEAR_VARS)
LOCAL_MODULE := RocketCore

LOCAL_EXPORT_C_INCLUDES := $(LOCAL_PATH)/include
LOCAL_C_INCLUDES := $(LOCAL_EXPORT_C_INCLUDES)
LOCAL_PCH := Source/Core/precompiled.h

LOCAL_STATIC_LIBRARIES := freetype

LOCAL_SRC_FILES := \
  Source/Core/BaseXMLParser.cpp \
  Source/Core/Box.cpp \
  Source/Core/Clock.cpp \
  Source/Core/Context.cpp \
  Source/Core/ContextInstancer.cpp \
  Source/Core/ContextInstancerDefault.cpp \
  Source/Core/ConvolutionFilter.cpp \
  Source/Core/Core.cpp \
  Source/Core/Decorator.cpp \
  Source/Core/DecoratorInstancer.cpp \
  Source/Core/DecoratorNone.cpp \
  Source/Core/DecoratorNoneInstancer.cpp \
  Source/Core/DecoratorTiled.cpp \
  Source/Core/DecoratorTiledBox.cpp \
  Source/Core/DecoratorTiledBoxInstancer.cpp \
  Source/Core/DecoratorTiledHorizontal.cpp \
  Source/Core/DecoratorTiledHorizontalInstancer.cpp \
  Source/Core/DecoratorTiledImage.cpp \
  Source/Core/DecoratorTiledImageInstancer.cpp \
  Source/Core/DecoratorTiledInstancer.cpp \
  Source/Core/DecoratorTiledVertical.cpp \
  Source/Core/DecoratorTiledVerticalInstancer.cpp \
  Source/Core/Dictionary.cpp \
  Source/Core/DocumentHeader.cpp \
  Source/Core/Element.cpp \
  Source/Core/ElementBackground.cpp \
  Source/Core/ElementBorder.cpp \
  Source/Core/ElementDecoration.cpp \
  Source/Core/ElementDefinition.cpp \
  Source/Core/ElementDocument.cpp \
  Source/Core/ElementHandle.cpp \
  Source/Core/ElementImage.cpp \
  Source/Core/ElementInstancer.cpp \
  Source/Core/ElementReference.cpp \
  Source/Core/ElementScroll.cpp \
  Source/Core/ElementStyle.cpp \
  Source/Core/ElementStyleCache.cpp \
  Source/Core/ElementText.cpp \
  Source/Core/ElementTextDefault.cpp \
  Source/Core/ElementUtilities.cpp \
  Source/Core/Event.cpp \
  Source/Core/EventDispatcher.cpp \
  Source/Core/EventInstancer.cpp \
  Source/Core/EventInstancerDefault.cpp \
  Source/Core/EventListenerInstancer.cpp \
  Source/Core/Factory.cpp \
  Source/Core/FileInterface.cpp \
  Source/Core/FileInterfaceDefault.cpp \
  Source/Core/FontDatabase.cpp \
  Source/Core/FontEffect.cpp \
  Source/Core/FontEffectInstancer.cpp \
  Source/Core/FontEffectNone.cpp \
  Source/Core/FontEffectNoneInstancer.cpp \
  Source/Core/FontEffectOutline.cpp \
  Source/Core/FontEffectOutlineInstancer.cpp \
  Source/Core/FontEffectShadow.cpp \
  Source/Core/FontEffectShadowInstancer.cpp \
  Source/Core/FontFace.cpp \
  Source/Core/FontFaceHandle.cpp \
  Source/Core/FontFaceLayer.cpp \
  Source/Core/FontFamily.cpp \
  Source/Core/Geometry.cpp \
  Source/Core/GeometryDatabase.cpp \
  Source/Core/GeometryUtilities.cpp \
  Source/Core/LayoutBlockBox.cpp \
  Source/Core/LayoutBlockBoxSpace.cpp \
  Source/Core/LayoutEngine.cpp \
  Source/Core/LayoutInlineBox.cpp \
  Source/Core/LayoutInlineBoxText.cpp \
  Source/Core/LayoutLineBox.cpp \
  Source/Core/Log.cpp \
  Source/Core/Math.cpp \
  Source/Core/Plugin.cpp \
  Source/Core/PluginRegistry.cpp \
  Source/Core/precompiled.cpp \
  Source/Core/Property.cpp \
  Source/Core/PropertyDefinition.cpp \
  Source/Core/PropertyDictionary.cpp \
  Source/Core/PropertyParserColour.cpp \
  Source/Core/PropertyParserKeyword.cpp \
  Source/Core/PropertyParserNumber.cpp \
  Source/Core/PropertyParserString.cpp \
  Source/Core/PropertySpecification.cpp \
  Source/Core/ReferenceCountable.cpp \
  Source/Core/RenderInterface.cpp \
  Source/Core/Stream.cpp \
  Source/Core/StreamFile.cpp \
  Source/Core/StreamMemory.cpp \
  Source/Core/String.cpp \
  Source/Core/StringCache.cpp \
  Source/Core/StringUtilities.cpp \
  Source/Core/StyleSheet.cpp \
  Source/Core/StyleSheetFactory.cpp \
  Source/Core/StyleSheetNode.cpp \
  Source/Core/StyleSheetNodeSelector.cpp \
  Source/Core/StyleSheetNodeSelectorEmpty.cpp \
  Source/Core/StyleSheetNodeSelectorFirstChild.cpp \
  Source/Core/StyleSheetNodeSelectorFirstOfType.cpp \
  Source/Core/StyleSheetNodeSelectorLastChild.cpp \
  Source/Core/StyleSheetNodeSelectorLastOfType.cpp \
  Source/Core/StyleSheetNodeSelectorNthChild.cpp \
  Source/Core/StyleSheetNodeSelectorNthLastChild.cpp \
  Source/Core/StyleSheetNodeSelectorNthLastOfType.cpp \
  Source/Core/StyleSheetNodeSelectorNthOfType.cpp \
  Source/Core/StyleSheetNodeSelectorOnlyChild.cpp \
  Source/Core/StyleSheetNodeSelectorOnlyOfType.cpp \
  Source/Core/StyleSheetParser.cpp \
  Source/Core/StyleSheetSpecification.cpp \
  Source/Core/SystemInterface.cpp \
  Source/Core/Template.cpp \
  Source/Core/TemplateCache.cpp \
  Source/Core/Texture.cpp \
  Source/Core/TextureDatabase.cpp \
  Source/Core/TextureLayout.cpp \
  Source/Core/TextureLayoutRectangle.cpp \
  Source/Core/TextureLayoutRow.cpp \
  Source/Core/TextureLayoutTexture.cpp \
  Source/Core/TextureResource.cpp \
  Source/Core/UnicodeRange.cpp \
  Source/Core/URL.cpp \
  Source/Core/Variant.cpp \
  Source/Core/WidgetSlider.cpp \
  Source/Core/WidgetSliderScroll.cpp \
  Source/Core/WString.cpp \
  Source/Core/XMLNodeHandler.cpp \
  Source/Core/XMLNodeHandlerBody.cpp \
  Source/Core/XMLNodeHandlerDefault.cpp \
  Source/Core/XMLNodeHandlerHead.cpp \
  Source/Core/XMLNodeHandlerTemplate.cpp \
  Source/Core/XMLParser.cpp \
  Source/Core/XMLParseTools.cpp

include $(BUILD_STATIC_LIBRARY)
